CON 
  _clkmode = xtal1 + pll16x 
  _xinfreq = 5_000_000 

  US_005 = 80_000_000 / 1_000_000 * 5                           ' 5us
    
  XB_Rx     = 3    ' XBee DOUT 
  XB_Tx     = 4    ' XBee DIN 
  XB_Baud   = 9600 
  CR        = 13                                        ' Carriage Return value       
  CLOCK     = 5                                         ' Connected to pin 2 of 74HC165
  LOAD      = 6                                         ' Connected to pin 1 of 74HC165
  DATA      = 7                                         ' Connected to pin 7 of 74HC165
  BITS_IN   = 8
  PC_Rx     = 31   
  PC_Tx     = 30 
  PC_Baud   = 9600
con

  #0, CLS, HOME, #8, BKSP, TAB, LF, CLREOL, CLRDN           ' PST formmatting control


var

   long stack1[150] 
   long stack2[150]
   long stack3[150]
  
   long Joystick[7]
   long Switches

   byte newDataFlag
                                                                         
OBJ 
   XB         : "FullDuplexSerial"
   ADC        : "jm_adc0838_ez"
   SR165      : "74HC165_121114a" 
   PC         : "FullDuplexSerial"         
Pub  Main
     
        'cognew(Read_ADC, @stack1)                         
        'cognew(Read_Switches, @stack2)                          
        cognew(XB_Send, @stack3)                                         
        'cognew(Display, @stack4)
        'dira[16..23] := outa[16..23] := 1              ' set pins from cog using the pins 
        'dira[16..23]~~  ' you already did this
        'XB.start(XB_Rx, XB_Tx, 0, XB_Baud)              ' Initialize comms for XBee
        ' moved to cog using the XB object

        PC.start(PC_Rx, PC_Tx, 0, PC_Baud)              ' Initialize comms for PC
        ' Keep this start here since this cog is using the PC object.
        
        ADC.init(0, 1, 2)                               ' Initialize ADC0838                                                 
        SR165.Init(CLOCK, LOAD, DATA)                   ' Initialize 74HC165                               
        Read_Sensors                                    ' Use original cog (#0) to read sensors.
        
PUB  Read_Sensors   | index
        
        repeat
          repeat while newDataFlag                      ' wait send method to clear newDataFlag
          ' The above is the same as "repeat while newDataFlag <> 0"
          
          repeat index from 0 to 7
            Joystick[index] := adc.read(index)          ' Read ADC
            Switches := SR165.ShiftIn(BITS_IN)          ' Read 74HC165
            newDataFlag := 1                            ' Let other methods know there is new data

PUB XB_Send   | index 

          dira[16..23] := outa[16..23] := 1             ' set I/O pins from cog using the pins
          repeat
            repeat while newDataFlag == 0                 ' wait send method to clear newDataFlag
            XB.tx("A")
            repeat index from 0 to 5
               XB.dec(Joystick[index])
               XB.tx(CR)
            XB.dec(Switches)
            XB.tx(CR)
            newDataFlag := 0
            Display                                     ' display the data while new data is being collected
            
PUB Display  | index  

         
          outa[16..23] := Switches
          repeat index from 0 to 7
            PC.tx(Joystick[index])                      
            PC.tx(CR)
          PC.dec(Joystick[0])
          PC.tx(CLS)
          PC.tx(HOME)
            
{PUB Display  | index  

          repeat
            outa[16..23] := Switches
            repeat index from 0 to 7
              PC.tx(Joystick[index])                     'Read ADCPC.dec()
              PC.tx(CR)
            PC.dec(Joystick[0])
            PC.tx(CLS)
            PC.tx(HOME)
}          